local Assemblage, _HomePrefix = ...

---------------------------------------------------------------------------------------------------
-- Versions V8.0.1
---------------------------------------------------------------------------------------------------
-- several models of door
    Assemblage:register({
	DataType = "BUILDING_PART",
	Id = _HomePrefix .. "_WOOD_DOOR_PART",
	ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
  		            CommonDoorPrefix .. "_ENTRANCE_WOODEN_DOOR_C_PART",
  		            CommonDoorPrefix .. "_ENTRANCE_WOODEN_DOOR_D_PART",
  		            CommonDoorPrefix .. "_ENTRANCE_WOODEN_DOOR_E_PART",
                          }
        }
    })
    Assemblage:register({
	DataType = "BUILDING_PART",
	Id = _HomePrefix .. "_STONE_DOOR_PART",
	ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
 		            CommonDoorPrefix .. "_ENTRANCE_DOOR_A_PART",
  		            CommonDoorPrefix .. "_ENTRANCE_DOOR_B_PART",
                          }
        }
    })

-- several models of window
    Assemblage:register({
	DataType = "BUILDING_PART",
	Id = _HomePrefix .. "_WOOD_WINDOW_PART",
	ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
		            CommonWindowPrefix .. "_DECORATION_WOODEN_WINDOW_1_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_WINDOW_18_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_WINDOW_3_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_WINDOW_9_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_WINDOW_7_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_WINDOW_8_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_LARGE_WINDOW_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_POINTED_WINDOW_1_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_ROUND_WINDOW_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_AMERICAN_WINDOW_1_PART",
                          }
        }
    })
    Assemblage:register({
	DataType = "BUILDING_PART",
	Id = _HomePrefix .. "_STONE_WINDOW_PART",
	ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
		            CommonWindowPrefix .. "_DECORATION_SFENETRE_PART",
		            CommonWindowPrefix .. "_DECORATION_LFENETRE_PART",
		            CommonWindowPrefix .. "_DECORATION_PFENETRE_PART",
		            CommonWindowPrefix .. "_DECORATION_ARROWSLIT_PART",
		            CommonWindowPrefix .. "_DECORATION_BALCONY_PART",
                          }
        }
    })

function registerRandomCore(_option, _core, _buildingZone, _villagerCapacity)
    function registerGroundFloorAssemblage(_buildingAssetId, _namePrefab, _material)
        function assignWindowsGroundFloor()
            -- MAIN floor: 1 door + 9 optional windows
            if (_core == "MAIN") then
                return {
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_DOOR_PART", Probability = 1 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_"  .. _material .. "_WINDOW_PART", Probability = 0.5 },
                }
            end
            -- KEEP floor: 1 door + 7 optional windows
            if (_core == "KEEP") then
                return {
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_DOOR_PART", Probability = 1 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                }
            end
            return {}
        end

    -- Register the main assemblage
        Assemblage:register({
	    DataType = "BUILDING_PART",
	    Id = _HomePrefix .. "_" .. _buildingAssetId .. "_PART",
	    Name = _HomePrefix .. "_" .. _buildingAssetId .. "_NAME",
	    Description = _HomePrefix .. "_" .. _buildingAssetId .. "_DESC",
	    Category = "CORE",
	    BuildingZone = _buildingZone,
	    ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { _namePrefab },
                MandatoryBuildingPartList = assignWindowsGroundFloor(),
                AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                         CustomValueList = {
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_" .. _material .. "_NEXT_FLOOR_PART",
                                                 AttachNodeString = "Attach_Major_rcv1mhw"
                                               }
                                         }                    
                }},
            },
            Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = _NoSandbox*0 }
		},
		RessourcesNeeded = {
			{ Resource = _material, Quantity = _NoSandbox*10 }
		}
	    },
       })
    end

-- several models of roof
    if (_core == "MAIN") then
        Assemblage:register({
	    DataType = "BUILDING_PART",
	    Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
	    ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
		            StoneGateSetPrefix .. "_MAIN_ROOF_4CLOSED45_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_2OPPOSITE45_PART", -- Opened roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_1OPENED45_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_4CLOSED30_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_2OPPOSITE30_PART", -- Opened roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_1OPENED30_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_4CLOSED60_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_2OPPOSITE60_PART", -- Opened roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_1OPENED60_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_DOME_4CLOSED_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_DOME_2OPPOSITE_PART", -- Opened roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_DOME_1OPENED_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_MAIN_POINTED_ROOF_4CLOSED_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_MAIN_POINTED_ROOF_2OPPOSITE_PART", -- Opened roof
		            StoneGateSetPrefix .. "_MAIN_POINTED_ROOF_1OPENED_PART",   -- half opened roof
                         }
            }
        })

    elseif (_core == "KEEP") then
        Assemblage:register({
	    DataType = "BUILDING_PART",
            Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
	    ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
		            StoneGateSetPrefix .. "_KEEP_ROOF_4CLOSED45_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_2OPPOSITE45_PART", -- Opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_1OPENED45_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_2ADJACENT45_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_3OPENED45_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_4OPENED45_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_4CLOSED30_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_2OPPOSITE30_PART", -- Opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_1OPENED30_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_2ADJACENT30_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_3OPENED30_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_4OPENED30_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_4CLOSED60_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_2OPPOSITE60_PART", -- Opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_1OPENED60_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_2ADJACENT60_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_3OPENED60_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_4OPENED60_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_DOME_4CLOSED_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_DOME_2OPPOSITE_PART", -- Opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_DOME_1OPENED_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_DOME_2ADJACENT_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_DOME_3OPENED_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_DOME_4OPENED_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_4CLOSED_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_2OPPOSITE_PART", -- Opened roof
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_1OPENED_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_2ADJACENT_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_3OPENED_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_4OPENED_PART",   -- half opened roof
                         }
            }
        })
    end

    function registerFloorAssemblage(_name, _nameModel, _material)
-- Register the extra floor assemblage
        function assignWindows()
            -- MAIN floor: 10 optional windows
            if (_core == "MAIN") then
                return {
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                }
            end
            -- KEEP floor: 8 optional windows
            if (_core == "KEEP") then
                return {
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                }
            end
        end

        Assemblage:register({
	    DataType = "BUILDING_PART",
	    Id = _HomePrefix .. "_" .. _name .. "_PART",
	    ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { _nameModel .. "_PREFAB" },
                MandatoryBuildingPartList = assignWindows(),
                AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                         CustomValueList = {
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_" .. _material .. "_NEXT_FLOOR_PART",
                                                 AttachNodeString = "Attach_Major_rcv1mhw"
                                               }
                                         }                    
                }},
            },
        })
    end
    registerFloorAssemblage(_option .. "_" .. "WF" .. _core .. "_D", StoneGateSetPrefix .. "_WF" .. _core .. "_D", "WOOD")
    registerFloorAssemblage(_option .. "_" .. "WHITE_WF" .. _core .. "_A", StoneGateSetPrefixWhiteFloor .. "_WF" .. _core .. "_A", "WOOD")
    registerFloorAssemblage(_option .. "_" .. "WHITE_WF" .. _core .. "_B", StoneGateSetPrefixWhiteFloor .. "_WF" .. _core .. "_B", "WOOD")
    registerFloorAssemblage(_option .. "_" .. "WHITE_WF" .. _core .. "_C", StoneGateSetPrefixWhiteFloor .. "_WF" .. _core .. "_C", "WOOD")
    registerFloorAssemblage(_option .. "_" .. _core .. "_TILING2", StoneGateSetPrefix .. "_" .. _core .. "_TILING2", "STONE")
    registerFloorAssemblage(_option .. "_" .. _core .. "_TILING2P", StoneGateSetPrefix .. "_" .. _core .. "_TILING2P", "STONE")

-- several models of floor
    Assemblage:register({
	DataType = "BUILDING_PART",
	Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_FLOOR_PART",
	ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
		            _HomePrefix .. "_" .. _option .. "_WF" .. _core .. "_D_PART",
		            _HomePrefix .. "_" .. _option .. "_WHITE_WF" .. _core .. "_A_PART",
		            _HomePrefix .. "_" .. _option .. "_WHITE_WF" .. _core .. "_B_PART",
		            _HomePrefix .. "_" .. _option .. "_WHITE_WF" .. _core .. "_C_PART",
                          }
        }
    })

-- next floor
    Assemblage:register({
	DataType = "BUILDING_PART",
	Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_NEXT_FLOOR_PART",
	ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_FLOOR_PART",
                         }
        }
    })

-- several models of floor
    Assemblage:register({
	DataType = "BUILDING_PART",
	Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_STONE_FLOOR_PART",
	ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_FLOOR_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_TILING2_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_TILING2P_PART",
                          }
        }
    })

-- next floor
    Assemblage:register({
	DataType = "BUILDING_PART",
	Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_STONE_NEXT_FLOOR_PART",
	ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_RAMPART_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_STONE_FLOOR_PART",
                         }
        }
    })

    function registerRampart(_name, _nameModel)
    -- Register the extra rampart assemblage
        Assemblage:register({
	    DataType = "BUILDING_PART",
            Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_PART",
	    ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
		            StoneGateSetPrefix .. "_" .. _core .. _nameModel .. "_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_ROOF_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_HOARDING_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_HOARDING_AND_ROOF_PART",
                         }
            }
        })
        Assemblage:register({
	    DataType = "BUILDING_PART",
	    Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_ROOF_PART",
	    ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { StoneGateSetPrefix .. "_" .. _core .. _nameModel .. "_PREFAB" },
                AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                         CustomValueList = {
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
                                                 AttachNodeString = "Attach_Major_rcv1mhw"
                                               }
                                         }                    
                }},
	    },
        })
        function assignHoarding()
            if (_core == "MAIN") then
                return {
                    { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S3L1R1_PART",
                      AttachNodeString = "Attach_Minor_F6_sgv8msr4c" },
                    { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S3L1R1_PART",
                      AttachNodeString = "Attach_Minor_B6_sgv8msr4c" },
                    { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                      AttachNodeString = "Attach_Minor_R4_sgv8msr4c" },
                    { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                      AttachNodeString = "Attach_Minor_L4_sgv8msr4c" },
                }                    
            end
            if (_core == "KEEP") then
                return {
                    { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                      AttachNodeString = "Attach_Minor_F6_sgv8ksr4c" },
                    { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                      AttachNodeString = "Attach_Minor_B6_sgv8ksr4c" },
                    { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                      AttachNodeString = "Attach_Minor_R4_sgv8ksr4c" },
                    { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                      AttachNodeString = "Attach_Minor_L4_sgv8ksr4c" },
                }                    
            end
            return {}
        end
        Assemblage:register({
	    DataType = "BUILDING_PART",
	    Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_HOARDING_PART",
	    ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { StoneGateSetPrefix .. "_" .. _core .. _nameModel .. "_PREFAB" },
                AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                         CustomValueList = assignHoarding()                    
                }},
	    },
        })
        function assignHoardingAndRoof()
            if (_core == "MAIN") then
                return {
                    { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S3L1R1_PART",
                      AttachNodeString = "Attach_Minor_F6_sgv8msr4c" },
                    { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S3L1R1_PART",
                      AttachNodeString = "Attach_Minor_B6_sgv8msr4c" },
                    { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                      AttachNodeString = "Attach_Minor_R4_sgv8msr4c" },
                    { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                      AttachNodeString = "Attach_Minor_L4_sgv8msr4c" },
                    { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
                      AttachNodeString = "Attach_Major_rampart_high2_sgv8msr4c" },
                }                    
            end
            if (_core == "KEEP") then
                return {
                    { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                      AttachNodeString = "Attach_Minor_F6_sgv8ksr4c" },
                    { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                      AttachNodeString = "Attach_Minor_B6_sgv8ksr4c" },
                    { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                      AttachNodeString = "Attach_Minor_R4_sgv8ksr4c" },
                    { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                      AttachNodeString = "Attach_Minor_L4_sgv8ksr4c" },
                    { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
                      AttachNodeString = "Attach_Major_rampart_high2_sgv8ksr4c" },
                }                    
            end
            return {}
        end
        Assemblage:register({
	    DataType = "BUILDING_PART",
	    Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_HOARDING_AND_ROOF_PART",
	    ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { StoneGateSetPrefix .. "_" .. _core .. _nameModel .. "_PREFAB" },
                AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                         CustomValueList = assignHoardingAndRoof()                    
                }},
	    },
        })
    end

    registerRampart("_RAMPART", "_RAMPART_4CLOSED")

    registerGroundFloorAssemblage(_option .. "_" .. _core .. "_TILING1", StoneGateSetPrefix .. "_" .. _core .. "_TILING1_PREFAB", "STONE")
    registerGroundFloorAssemblage(_option .. "_" .. _core .. "_TILING1P", StoneGateSetPrefix .. "_" .. _core .. "_TILING1P_PREFAB", "STONE")
    registerGroundFloorAssemblage(_option .. "_" .. _core .. "_TILING1HALFWHITE", StoneGateSetPrefix .. "_" .. _core .. "_TILING1HALFWHITE_PREFAB", "WOOD")

    function registerPlaceableHouse()
        Assemblage:register({
	    DataType = "BUILDING_PART",
	    Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_PART",
	    Name = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_NAME",
	    Description = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_DESC",
	    Category = "CORE",
	    BuildingZone = _buildingZone,
	    ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
                    _HomePrefix .. "_" .. _option .. "_" .. _core .. "_TILING1_PART",
                    _HomePrefix .. "_" .. _option .. "_" .. _core .. "_TILING1P_PART",
                    _HomePrefix .. "_" .. _option .. "_" .. _core .. "_TILING1HALFWHITE_PART" },
	    },
            VillagerCapacity = _villagerCapacity,
	    AssetBuildingFunction = registerAssignableFunction(_HomePrefix, _option .. "_" .. _core)
        })
    end

    registerPlaceableHouse()
end

registerRandomCore("ALL", "MAIN", _MainBuildingZone, 6)
registerRandomCore("ALL", "KEEP", _KeepBuildingZone, 4)
