local StoneGate = ...

-- Apply building asset processor
StoneGate:registerAssetProcessor("models/hoardings/hoardingS2.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/hoardings/extensionS2.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/hoardings/hoardingS3.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/hoardings/extensionS3.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/hoardings/hoardingS1.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/hoardings/hoardingA45.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/hoardings/hoardingSmallGate.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/hoardings/hoardingSmallGate2.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/hoardings/hoardingOctogonalTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/hoardings/hoardingCircularTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

-- Register Small Squared Tower materials
StoneGate:registerAssetId("models/hoardings/hoardingS2.fbx/Materials/blueCrenellation", StoneGateSetPrefix .. "_HOARDING_S2_STONE_MANOR_CRENELLATION_MATERIAL")
StoneGate:registerAssetId("models/hoardings/extensionS2.fbx/Materials/blueCrenellation", StoneGateSetPrefix .. "_HOARDING_EXTENSION_S2_STONE_MANOR_CRENELLATION_MATERIAL")
StoneGate:registerAssetId("models/hoardings/hoardingS3.fbx/Materials/blueCrenellation", StoneGateSetPrefix .. "_HOARDING_S3_STONE_MANOR_CRENELLATION_MATERIAL")
StoneGate:registerAssetId("models/hoardings/extensionS3.fbx/Materials/blueCrenellation", StoneGateSetPrefix .. "_HOARDING_EXTENSION_S3_STONE_MANOR_CRENELLATION_MATERIAL")
StoneGate:registerAssetId("models/hoardings/hoardingS1.fbx/Materials/blueCrenellation", StoneGateSetPrefix .. "_HOARDING_S1_STONE_MANOR_CRENELLATION_MATERIAL")
StoneGate:registerAssetId("models/hoardings/hoardingA45.fbx/Materials/blueCrenellation", StoneGateSetPrefix .. "_HOARDING_A45_STONE_MANOR_CRENELLATION_MATERIAL")
StoneGate:registerAssetId("models/hoardings/hoardingSmallGate.fbx/Materials/blueCrenellation", StoneGateSetPrefix .. "_HOARDING_SGATE_STONE_MANOR_CRENELLATION_MATERIAL")
StoneGate:registerAssetId("models/hoardings/hoardingSmallGate2.fbx/Materials/blueCrenellation", StoneGateSetPrefix .. "_HOARDING_SGATE2_STONE_MANOR_CRENELLATION_MATERIAL")
StoneGate:registerAssetId("models/hoardings/hoardingOctogonalTower.fbx/Materials/blueCrenellation", StoneGateSetPrefix .. "_HOARDING_OTOWER_STONE_MANOR_CRENELLATION_MATERIAL")
StoneGate:registerAssetId("models/hoardings/hoardingCircularTower.fbx/Materials/blueCrenellation", StoneGateSetPrefix .. "_HOARDING_CIRCULAR_STONE_MANOR_CRENELLATION_MATERIAL")

function registerHoardingPart(_nameSize, _nameFbx, _nameAsset)
    StoneGate:registerAssetId("models/hoardings/" .. _nameSize .. ".fbx/Prefab/hoarding/step_5_" .. _nameFbx .. "Part", StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set decoration hoardings part
    StoneGate:register({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PART",
	Name = StoneGateSetPrefix .. "_" .. _nameAsset .. "_NAME",
	Description = StoneGateSetPrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB",
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "PLANK", Quantity = 2*_NoSandbox }
		}
	}
    })

    StoneGate:registerPrefabComponent("models/hoardings/" .. _nameSize .. ".fbx/Prefab/hoarding/step_5_" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR"
    })
end

function registerHoardingPartMajor(_nameSize, _nameFbx, _nameAsset)
    StoneGate:registerAssetId("models/hoardings/" .. _nameSize .. ".fbx/Prefab/hoarding/step_5_" .. _nameFbx .. "Part", StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set decoration hoarding part
    StoneGate:register({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PART",
	Name = StoneGateSetPrefix .. "_" .. _nameAsset .. "_NAME",
	Description = StoneGateSetPrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB",
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "PLANK", Quantity = 2*_NoSandbox }
		}
	}
    })
end

registerHoardingPart( "hoardingS2", "Hoarding_S2L0R0", "HOARDING_S2L0R0" )
registerHoardingPart( "hoardingS2", "Hoarding_S2L0R1", "HOARDING_S2L0R1" )
registerHoardingPart( "hoardingS2", "Hoarding_S2L1R0", "HOARDING_S2L1R0" )
registerHoardingPart( "hoardingS2", "Hoarding_S2L1R1", "HOARDING_S2L1R1" )
registerHoardingPart( "extensionS2", "Extension_S2L0R0", "EXTENSION_S2L0R0" )
registerHoardingPart( "hoardingS3", "Hoarding_S3L0R0", "HOARDING_S3L0R0" )
registerHoardingPart( "hoardingS3", "Hoarding_S3L0R1", "HOARDING_S3L0R1" )
registerHoardingPart( "hoardingS3", "Hoarding_S3L1R0", "HOARDING_S3L1R0" )
registerHoardingPart( "hoardingS3", "Hoarding_S3L1R1", "HOARDING_S3L1R1" )
registerHoardingPart( "extensionS3", "Extension_S3L0R0", "EXTENSION_S3L0R0" )
registerHoardingPartMajor( "hoardingS1", "Sst_HoardingA", "HOARDING_S1_A" )
registerHoardingPartMajor( "hoardingS1", "Sst_HoardingB", "HOARDING_S1_B" )
registerHoardingPartMajor( "hoardingS1", "Sst_HoardingC", "HOARDING_S1_C" )
registerHoardingPartMajor( "hoardingS1", "Sst_HoardingD", "HOARDING_S1_D" )
registerHoardingPartMajor( "hoardingA45", "A45_HoardingD", "HOARDING_A45_D" )
registerHoardingPartMajor( "hoardingSmallGate", "SmallGate_HoardingD", "HOARDING_SGATE_D" )
registerHoardingPartMajor( "hoardingSmallGate", "SmallGate_Hoarding_Extension", "HOARDING_SGATE_EXTENSION" )
registerHoardingPart( "hoardingSmallGate2", "SmallGate_HoardingA", "HOARDING_SGATE_A" )
registerHoardingPart( "hoardingOctogonalTower", "Octogonal_HoardingExt", "OTOWER_HOARDING_EXT" )
registerHoardingPart( "hoardingOctogonalTower", "Octogonal_Hoarding", "OTOWER_HOARDING" )
registerHoardingPartMajor( "hoardingCircularTower", "Circular_Hoarding", "CIRCULAR_HOARDING" )

