local StoneGate = ...

-- Apply building asset processor
StoneGate:registerAssetProcessor("models/machicolations/machicolationKeepPlatform.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/machicolations/machicolationCrenation.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/machicolations/machicolationMainPlatform.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/machicolations/machicolationSmallSquaredTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/machicolations/machicolationAngle45.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/machicolations/machicolationSmallGate.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/machicolations/machicolationSmallGate2.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/machicolations/machicolationOctogonalTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/machicolations/machicolationCircularTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/machicolations/machicolationSmallCircularTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

-- Register materials
function registerRoofMaterial(_fbxName, _assetName)
        StoneGate:registerAssetId("models/machicolations/machicolation" .. _fbxName .. ".fbx/Materials/redRoof", StoneGateSetPrefix .. "_MACHICOLATION_" .. _assetName .. "_RED_TILE_ROOF_MATERIAL")
end
registerRoofMaterial("KeepPlatform", "KEEP")
registerRoofMaterial("MainPlatform", "MAIN")
registerRoofMaterial("SmallSquaredTower", "SST")
registerRoofMaterial("SmallGate", "SGATE")
registerRoofMaterial("SmallGate2", "SGATE2") -- for covered pathwalk over half-roof
registerRoofMaterial("Angle45", "A45")
registerRoofMaterial("OctogonalTower", "OTOWER")
registerRoofMaterial("CircularTower", "CIRCULAR")
registerRoofMaterial("SmallCircularTower", "SCT")

function registerWallMaterial(_fbxName, _assetName)
    StoneGate:registerAssetId("models/machicolations/machicolation" .. _fbxName .. ".fbx/Materials/murChateau", StoneGateSetPrefix .. "_MACHICOLATION_" .. _assetName .. "_STONE_MANOR_WALL_MATERIAL")
end
registerWallMaterial("KeepPlatform", "KEEP")
registerWallMaterial("MainPlatform", "MAIN")
registerWallMaterial("SmallSquaredTower", "SST")
registerWallMaterial("SmallGate", "SGATE")
registerWallMaterial("Angle45", "A45")
registerWallMaterial("OctogonalTower", "OTOWER")
registerWallMaterial("CircularTower", "CIRCULAR")
registerWallMaterial("SmallCircularTower", "SCT")

function registerCrenellationMaterial(_fbxName, _assetName)
    StoneGate:registerAssetId("models/machicolations/machicolation" .. _fbxName .. ".fbx/Materials/blueCrenellation", StoneGateSetPrefix .. "_MACHICOLATION_" .. _assetName .. "_STONE_MANOR_CRENELLATION_MATERIAL")
end
registerCrenellationMaterial("KeepPlatform", "KEEP")
registerCrenellationMaterial("Crenation", "CRENATION")
registerCrenellationMaterial("MainPlatform", "MAIN")
registerCrenellationMaterial("SmallSquaredTower", "SST")
registerCrenellationMaterial("SmallGate", "SGATE")
registerCrenellationMaterial("SmallGate2", "SGATE2") -- for covered pathwalk over half-roof
registerCrenellationMaterial("Angle45", "A45")
registerCrenellationMaterial("OctogonalTower", "OTOWER")
registerCrenellationMaterial("CircularTower", "CIRCULAR")
registerCrenellationMaterial("SmallCircularTower", "SCT")

function registerFlourGroundMaterial(_fbxName, _assetName)
    StoneGate:registerAssetId("models/machicolations/machicolation" .. _fbxName .. ".fbx/Materials/whiteStoneGround", StoneGateSetPrefix .. "_MACHICOLATION_" .. _assetName .. "_WHITE_STONE_FLOOR_GROUND_MATERIAL")
end
registerFlourGroundMaterial("KeepPlatform", "KEEP")
registerFlourGroundMaterial("MainPlatform", "MAIN")
registerFlourGroundMaterial("SmallSquaredTower", "SST")
registerFlourGroundMaterial("SmallGate", "SGATE")
registerFlourGroundMaterial("SmallGate2", "SGATE2") -- for covered pathwalk over half-roof
registerFlourGroundMaterial("Angle45", "A45")
registerFlourGroundMaterial("OctogonalTower", "OTOWER")
registerFlourGroundMaterial("CircularTower", "CIRCULAR")
registerFlourGroundMaterial("SmallCircularTower", "SCT")

function registerFrameMaterial(_fbxName, _assetName)
    StoneGate:registerAssetId("models/machicolations/machicolation" .. _fbxName .. ".fbx/Materials/whiteStoneFrame", StoneGateSetPrefix .. "_MACHICOLATION_" .. _assetName .. "_WHITE_STONE_FRAME_MATERIAL")
end
registerFrameMaterial("KeepPlatform", "KEEP")
registerFrameMaterial("MainPlatform", "MAIN")
registerFrameMaterial("SmallSquaredTower", "SST")
registerFrameMaterial("SmallGate", "SGATE")
registerFrameMaterial("SmallGate2", "SGATE2") -- for covered pathwalk over half-roof
registerFrameMaterial("Angle45", "A45")
registerFrameMaterial("OctogonalTower", "OTOWER")
registerFrameMaterial("CircularTower", "CIRCULAR")
registerFrameMaterial("SmallCircularTower", "SCT")

function registerMachicolationPart(_nameSize, _nameFbx, _nameAsset, _buildingPartType)
    StoneGate:registerAssetId("models/machicolations/" .. _nameSize .. ".fbx/Prefab/machicolation/" .. _nameFbx .. "Part", StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set machicolation platform part
    StoneGate:register({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PART",
	Name = StoneGateSetPrefix .. "_" .. _nameAsset .. "_NAME",
	Description = StoneGateSetPrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB",
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2*_NoSandbox }
		}
	}
    })

    StoneGate:registerPrefabComponent("models/machicolations/" .. _nameSize .. ".fbx/Prefab/machicolation/" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = _buildingPartType
    })
end

registerMachicolationPart( "machicolationKeepPlatform", "step_4_Keep_MachicolationC", "MACHICOLATION_KEEP_C", "MAJOR" )
registerMachicolationPart( "machicolationKeepPlatform", "step_4_Keep_MachicolationCP", "MACHICOLATION_KEEP_C_P", "MAJOR" )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation34", "MACHICOLATION_CRENATION34", "MINOR" )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation40R", "MACHICOLATION_CRENATION40R", "MINOR" )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation40L", "MACHICOLATION_CRENATION40L", "MINOR" )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation50", "MACHICOLATION_CRENATION50", "MINOR" )
registerMachicolationPart( "machicolationKeepPlatform", "step_6_Keep_MachicolationRoofC", "MACHICOLATION_KEEP_ROOF_C", "MAJOR" )
registerMachicolationPart( "machicolationMainPlatform", "step_4_Main_MachicolationD", "MACHICOLATION_MAIN_D", "MAJOR" )
registerMachicolationPart( "machicolationMainPlatform", "step_4_Main_MachicolationDP", "MACHICOLATION_MAIN_D_P", "MAJOR" )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation54", "MACHICOLATION_CRENATION54", "MINOR" )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation60R", "MACHICOLATION_CRENATION60R", "MINOR" )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation60L", "MACHICOLATION_CRENATION60L", "MINOR" )
registerMachicolationPart( "machicolationCrenation", "step_5_Machicolation_Crenation70", "MACHICOLATION_CRENATION70", "MINOR" )
registerMachicolationPart( "machicolationMainPlatform", "step_6_Main_MachicolationRoofD", "MACHICOLATION_MAIN_ROOF_D", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_4_Sst_MachicolationA", "MACHICOLATION_SST_RAMPART_A", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_4_Sst_MachicolationB", "MACHICOLATION_SST_RAMPART_B", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_4_Sst_MachicolationC", "MACHICOLATION_SST_RAMPART_C", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_4_Sst_MachicolationD", "MACHICOLATION_SST_RAMPART_D", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_4_Sst_MachicolationE", "MACHICOLATION_SST_RAMPART_E", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_4_Sst_MachicolationAP", "MACHICOLATION_SST_RAMPART_AP", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_4_Sst_MachicolationBP", "MACHICOLATION_SST_RAMPART_BP", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_4_Sst_MachicolationCP", "MACHICOLATION_SST_RAMPART_CP", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_4_Sst_MachicolationDP", "MACHICOLATION_SST_RAMPART_DP", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_4_Sst_MachicolationEP", "MACHICOLATION_SST_RAMPART_EP", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_6_Sst_RoofMA", "MACHICOLATION_SST_ROOF_A", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_6_Sst_RoofMB", "MACHICOLATION_SST_ROOF_B", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_6_Sst_RoofMC", "MACHICOLATION_SST_ROOF_C", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_6_Sst_RoofMD", "MACHICOLATION_SST_ROOF_D", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_6_Sst_RoofMA45", "MACHICOLATION_SST_ROOF_A45", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_6_Sst_RoofMB45", "MACHICOLATION_SST_ROOF_B45", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_6_Sst_RoofMC45", "MACHICOLATION_SST_ROOF_C45", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_6_Sst_RoofMD45", "MACHICOLATION_SST_ROOF_D45", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_6_Sst_RoofMA30", "MACHICOLATION_SST_ROOF_A30", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_6_Sst_RoofMB30", "MACHICOLATION_SST_ROOF_B30", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_6_Sst_RoofMC30", "MACHICOLATION_SST_ROOF_C30", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_6_Sst_RoofMD30", "MACHICOLATION_SST_ROOF_D30", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_6_Sst_RoofMA60", "MACHICOLATION_SST_ROOF_A60", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_6_Sst_RoofMB60", "MACHICOLATION_SST_ROOF_B60", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_6_Sst_RoofMC60", "MACHICOLATION_SST_ROOF_C60", "MAJOR" )
registerMachicolationPart( "machicolationSmallSquaredTower", "step_6_Sst_RoofMD60", "MACHICOLATION_SST_ROOF_D60", "MAJOR" )
registerMachicolationPart( "machicolationSmallGate", "step_4_SmallGate_MachicolationC", "MACHICOLATION_SGATE_RAMPART_C", "MAJOR" )
registerMachicolationPart( "machicolationSmallGate", "step_4_SmallGate_MachicolationE", "MACHICOLATION_SGATE_RAMPART_E", "MAJOR" )
registerMachicolationPart( "machicolationSmallGate", "step_4_SmallGate_MachicolationCP", "MACHICOLATION_SGATE_RAMPART_CP", "MAJOR" )
registerMachicolationPart( "machicolationSmallGate", "step_4_SmallGate_MachicolationEP", "MACHICOLATION_SGATE_RAMPART_EP", "MAJOR" )
registerMachicolationPart( "machicolationSmallGate", "step_6_SmallGate_RoofMD", "MACHICOLATION_SGATE_ROOF_D", "MAJOR" )
registerMachicolationPart( "machicolationSmallGate", "step_6_SmallGate_RoofMD45", "MACHICOLATION_SGATE_ROOF_D45", "MAJOR" )
registerMachicolationPart( "machicolationSmallGate", "step_6_SmallGate_RoofMD30", "MACHICOLATION_SGATE_ROOF_D30", "MAJOR" )
registerMachicolationPart( "machicolationSmallGate", "step_6_SmallGate_RoofMD60", "MACHICOLATION_SGATE_ROOF_D60", "MAJOR" )
registerMachicolationPart( "machicolationSmallGate2", "step_4_SGate_MachicolationA", "SGATE_MACHICOLATION_A", "MINOR" )
registerMachicolationPart( "machicolationSmallGate2", "step_4_SGate_MachicolationAP", "SGATE_MACHICOLATION_AP", "MINOR" )
registerMachicolationPart( "machicolationSmallGate2", "step_5_SGate_MachicolationClosingL", "SGATE_MACHICOLATION_CLOSING_L", "MAJOR" )
registerMachicolationPart( "machicolationSmallGate2", "step_5_SGate_MachicolationClosingR", "SGATE_MACHICOLATION_CLOSING_R", "MAJOR" )
registerMachicolationPart( "machicolationSmallGate2", "step_4_SGate_WoodenRoofA", "SGATE_MACHICOLATION_WOODEN_ROOF_A", "MAJOR" )
registerMachicolationPart( "machicolationSmallGate2", "step_4_SGate_StoneRoofA", "SGATE_MACHICOLATION_STONE_ROOF_A", "MAJOR" )
registerMachicolationPart( "machicolationAngle45", "step_4_A45_MachicolationE", "MACHICOLATION_A45_RAMPART_E", "MAJOR" )
registerMachicolationPart( "machicolationAngle45", "step_4_A45_MachicolationEP", "MACHICOLATION_A45_RAMPART_EP", "MAJOR" )
registerMachicolationPart( "machicolationAngle45", "step_6_A45_RoofME", "MACHICOLATION_A45_ROOF_E", "MAJOR" )
registerMachicolationPart( "machicolationAngle45", "step_6_A45_RoofME45", "MACHICOLATION_A45_ROOF_E45", "MAJOR" )
registerMachicolationPart( "machicolationAngle45", "step_6_A45_RoofME30", "MACHICOLATION_A45_ROOF_E30", "MAJOR" )
registerMachicolationPart( "machicolationAngle45", "step_6_A45_RoofME60", "MACHICOLATION_A45_ROOF_E60", "MAJOR" )
registerMachicolationPart( "machicolationOctogonalTower", "step_4_Octogonal_Machicolation", "OTOWER_MACHICOLATION", "MAJOR" )
registerMachicolationPart( "machicolationOctogonalTower", "step_4_Octogonal_MachicolationB", "OTOWER_MACHICOLATION_B", "MAJOR" )
registerMachicolationPart( "machicolationOctogonalTower", "step_6_Octogonal_MachicolationRoof", "OTOWER_MACHICOLATION_ROOF", "MAJOR" )
registerMachicolationPart( "machicolationCircularTower", "step_4_Circular_MachicolationA", "CIRCULAR_MACHICOLATION_A", "MAJOR" )
registerMachicolationPart( "machicolationCircularTower", "step_4_Circular_MachicolationB", "CIRCULAR_MACHICOLATION_B", "MAJOR" )
registerMachicolationPart( "machicolationCircularTower", "step_6_Circular_MachicolationRoof", "CIRCULAR_MACHICOLATION_PLATFORM", "MAJOR" )
registerMachicolationPart( "machicolationSmallCircularTower", "step_4_Sct_MachicolationA", "MACHICOLATION_SCT_RAMPART_A", "MAJOR" )
registerMachicolationPart( "machicolationSmallCircularTower", "step_4_Sct_MachicolationB", "MACHICOLATION_SCT_RAMPART_B", "MAJOR" )
registerMachicolationPart( "machicolationSmallCircularTower", "step_4_Sct_MachicolationAP", "MACHICOLATION_SCT_RAMPART_AP", "MAJOR" )
registerMachicolationPart( "machicolationSmallCircularTower", "step_4_Sct_MachicolationBP", "MACHICOLATION_SCT_RAMPART_BP", "MAJOR" )
registerMachicolationPart( "machicolationSmallCircularTower", "step_6_Sct_RoofMA", "MACHICOLATION_SCT_ROOF_A", "MAJOR" )
registerMachicolationPart( "machicolationSmallCircularTower", "step_6_Sct_RoofMA45", "MACHICOLATION_SCT_ROOF_A45", "MAJOR" )
registerMachicolationPart( "machicolationSmallCircularTower", "step_6_Sct_RoofMA30", "MACHICOLATION_SCT_ROOF_A30", "MAJOR" )
registerMachicolationPart( "machicolationSmallCircularTower", "step_6_Sct_RoofMA60", "MACHICOLATION_SCT_ROOF_A60", "MAJOR" )
