local StoneGate = ...

-- Apply building asset processor
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorMain.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorKeep.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorSmallSquaredTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorSmallGate.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorCircularTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorOctogonalTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorSmallCircularTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorAngle45.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenDecorations.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

function registerSimpleDecorationPart(_nameFbxFile, _nameFbx, _nameAsset)
    StoneGate:registerAssetId("models/woodenFloors/" .. _nameFbxFile .. ".fbx/Prefab/woodenFloor/" .. _nameFbx .. "Part", StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set decoration roof part
    StoneGate:register({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PART",
	Name = StoneGateSetPrefix .. "_" .. _nameAsset .. "_NAME",
	Description = StoneGateSetPrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB",
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "PLANK", Quantity = 2*_NoSandbox }
		}
	}
    })
end

function configurePlatformPart(_nameFbxFile, _nameFbx, _nameAsset)
    registerSimpleDecorationPart(_nameFbxFile, _nameFbx, _nameAsset)
    StoneGate:configurePrefabFlagList("models/woodenFloors/" .. _nameFbxFile .. ".fbx/Prefab/woodenFloor/" .. _nameFbx .. "Part", { "PLATFORM" })
end
configurePlatformPart("woodenDecorations", "step_2_WFDecorationD", "WFDECORATION_D" ) -- platform

registerSimpleDecorationPart( "woodenDecorations", "step_2_WFDecorationE", "WFDECORATION_E" )
registerSimpleDecorationPart( "woodenDecorations", "step_2_WFDecorationF", "WFDECORATION_F" )
registerSimpleDecorationPart( "woodenDecorations", "step_2_WFDecorationG", "WFDECORATION_G" )
registerSimpleDecorationPart( "woodenDecorations", "step_2_WFDecorationStairRailR", "WFDECORATION_STAIR_RAIL_R" )
registerSimpleDecorationPart( "woodenDecorations", "step_2_WFDecorationStairRailL", "WFDECORATION_STAIR_RAIL_L" )

function registerWoodenFloorOptionPart(_option)
function registerWoodenFloorPart(_nameFbxFile, _nameFbx, _nameAsset, _villagerCapacity)
    StoneGate:registerAssetId("models/woodenFloors/" .. _nameFbxFile .. ".fbx/Prefab/woodenFloor/" .. _nameFbx .. "Part", StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set decoration roof part
    StoneGate:register({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PART",
	Name = StoneGateSetPrefix .. "_" .. _nameAsset .. "_NAME",
	Description = StoneGateSetPrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB",
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "PLANK", Quantity = 5*_NoSandbox }
		}
	},
    })
end

    registerWoodenFloorPart( "woodenFloorMain", "step_2_WFMain" .. _option, "WFMAIN_" .. _option, 12 )
    registerWoodenFloorPart( "woodenFloorKeep", "step_2_WFKeep" .. _option, "WFKEEP_" .. _option, 8 )
    registerWoodenFloorPart( "woodenFloorSmallSquaredTower", "step_2_WFSst" .. _option, "WFSST_" .. _option, 2 )
    registerWoodenFloorPart( "woodenFloorSmallGate", "step_2_WFSGate" .. _option, "WFSGATE_" .. _option, 0 )
    registerWoodenFloorPart( "woodenFloorAngle45", "step_2_WFA45" .. _option, "WFA45_" .. _option, 0 )
    registerWoodenFloorPart( "woodenFloorOctogonalTower", "step_2_WFOctogonal" .. _option, "WFOCTOGONAL_" .. _option, 8 )
    registerWoodenFloorPart( "woodenFloorCircularTower", "step_2_WFCircular" .. _option, "WFCIRCULAR_" .. _option, 6 )
    registerWoodenFloorPart( "woodenFloorSmallCircularTower", "step_2_WFSct" .. _option, "WFSCT_" .. _option, 0 )
end

registerWoodenFloorOptionPart("A")
registerWoodenFloorOptionPart("B")
registerWoodenFloorOptionPart("C")
registerWoodenFloorOptionPart("D")

function registerWoodenFloorPlatform(_nameFbxFile, _nameFbx)
    StoneGate:configurePrefabFlagList("models/woodenFloors/" .. _nameFbxFile .. ".fbx/Prefab/woodenFloor/" .. _nameFbx .. "Part", { "PLATFORM" })
end
registerWoodenFloorPlatform( "woodenFloorSmallGate", "step_2_WFSGateA")
registerWoodenFloorPlatform( "woodenFloorSmallGate", "step_2_WFSGateB")
registerWoodenFloorPlatform( "woodenFloorSmallGate", "step_2_WFSGateC")
registerWoodenFloorPlatform( "woodenFloorSmallGate", "step_2_WFSGateD")
